%global with_debug 0
%global with_check 0

%if 0%{?with_debug}
%global _find_debuginfo_dwz_opts %{nil}
%global _dwz_low_mem_die_limit 0
%else
%global debug_package %{nil}
%endif

%global provider github
%global provider_tld com
%global project containers
%global repo conmon
# https://github.com/containers/conmon
%global import_path %{provider}.%{provider_tld}/%{project}/%{repo}
%global commit0 7a830be343876ac381c965c7429a7fb9b3d7a609
%global shortcommit0 %(c=%{commit0}; echo ${c:0:7})
%global git0 https://%{import_path}

# Used for comparing with latest upstream tag
# to decide whether to autobuild (non-rawhide only)
%define built_tag v2.0.15
%define built_tag_strip %(b=%{built_tag}; echo ${b:1})

Name: %{repo}
Epoch: 2
Version: 2.0.15
Release: 1%{?dist}
Summary: OCI container runtime monitor
License: ASL 2.0
URL: https://github.com/containers/%{name}
Source0: %{url}/archive/%{built_tag}.tar.gz
# Use below line to build a random commit
#Source0: %%{git0}/archive/%%{commit0}/%%{name}-%%{shortcommit0}.tar.gz
BuildRequires: gcc
BuildRequires: git
BuildRequires: glib2-devel
BuildRequires: systemd-devel
BuildRequires: systemd-libs
Requires: systemd-libs

%description
%{summary}.

%prep
%autosetup -Sgit -n %{name}-%{built_tag_strip}
# use below line to build a random commit
#%%autosetup -Sgit -n %%{name}-%%{commit0}

%build
%{__make} all

%install
%{__make} PREFIX=%{buildroot}%{_prefix} install install.crio

#define license tag if not already defined
%{!?_licensedir:%global license %doc}

%files
%license LICENSE
%doc README.md
%{_bindir}/%{name}
%{_libexecdir}/crio/%{name}

%changelog
* Thu Apr 02 2020 RH Container Bot <rhcontainerbot@fedoraproject.org> - 2:2.0.15-1
- autobuilt v2.0.15

* Fri Mar 20 2020 RH Container Bot <rhcontainerbot@fedoraproject.org> - 2:2.0.14-1
- autobuilt v2.0.14

* Tue Mar 17 2020 RH Container Bot <rhcontainerbot@fedoraproject.org> - 2:2.0.13-1
- autobuilt v2.0.13

* Mon Mar 16 2020 RH Container Bot <rhcontainerbot@fedoraproject.org> - 2:2.0.12-1
- autobuilt v2.0.12

* Thu Mar 12 2020 Lokesh Mandvekar <lsm5@fedoraproject.org> - 2:2.0.11-2
- Resolves: containers/libpod#5467

* Wed Mar 04 2020 RH Container Bot <rhcontainerbot@fedoraproject.org> - 2:2.0.11-1
- autobuilt v2.0.11

* Sat Jan 25 2020 Lokesh Mandvekar <lsm5@fedoraproject.org> - 2:2.0.10-7
- 2.0.10-7 for obs test

* Sat Jan 25 2020 Lokesh Mandvekar <lsm5@fedoraproject.org> - 2:2.0.10-6
- test

* Sat Jan 25 2020 Lokesh Mandvekar <lsm5@fedoraproject.org> - 2:2.0.10-5
- bump for OBS test

* Sat Jan 25 2020 Lokesh Mandvekar <lsm5@fedoraproject.org> - 2:2.0.10-4
- bump for OBS test

* Sat Jan 25 2020 Lokesh Mandvekar <lsm5@fedoraproject.org> - 2:2.0.10-3
- bump for OBS test

* Thu Jan 23 2020 RH Container Bot <rhcontainerbot@fedoraproject.org> - 2:2.0.10-2
- bump to v2.0.10
- autobuilt 7a830be

* Mon Jan 06 2020 RH Container Bot <rhcontainerbot@fedoraproject.org> - 2:2.0.9-2
- bump to v2.0.9
- autobuilt 60b42f2

* Wed Jan 01 2020 RH Container Bot <rhcontainerbot@fedoraproject.org> - 2:2.0.8-2
- bump to v2.0.8
- autobuilt 5ca7df2

* Mon Dec 16 2019 Jindrich Novy <jnovy@redhat.com> - 2:2.0.8-1
- bump to v2.0.8

* Mon Oct 21 2019 Lokesh Mandvekar <lsm5@fedoraproject.org> - 2:2.0.2-1
- bump to v2.0.2

* Wed Sep 25 2019 Lokesh Mandvekar <lsm5@fedoraproject.org> - 2:2.0.1-1
- Resolves: #1753594, #1753671
- bump to v2.0.1

* Tue Sep 10 2019 Lokesh Mandvekar <lsm5@fedoraproject.org> - 2:2.0.0-2
- remove BR: go-md2man since no manpages yet

* Tue Sep 10 2019 Lokesh Mandvekar <lsm5@fedoraproject.org> - 2:2.0.0-1
- bump to v2.0.0

* Fri May 31 2019 Lokesh Mandvekar <lsm5@fedoraproject.org> - 2:0.2.0-1
- initial package
