Name: libvirt-python
Version: 6.6.0
Release: 1%{?dist}%{?extra_release}
Source0: http://libvirt.org/sources/python/%{name}-%{version}.tar.gz
Url: http://libvirt.org
License: LGPLv2+
Summary: The libvirt virtualization API python2 binding
Group: Development/Libraries
BuildRequires: libvirt-devel == %{version}
BuildRequires: python3-devel
BuildRequires: python3-nose
BuildRequires: python3-lxml
Provides: python3-libvirt
Provides: libvirt-python3 = %{version}-%{release}
Obsoletes: libvirt-python3 <= 3.6.0-1%{?dist}


%{?filter_provides_in: %filter_provides_in %{python3_sitearch}/.*\.so}
%{?filter_setup}


%description
The libvirt-python package contains a module that permits applications
written in the Python programming language to use the interface
supplied by the libvirt library to use the virtualization capabilities
of recent versions of Linux (and other OSes).


%prep
%setup -q
find examples -type f -exec chmod 0644 \{\} \;


%build
CFLAGS="$RPM_OPT_FLAGS" %{__python3} setup.py build


%install
%{__python3} setup.py install --skip-build --root=%{buildroot}


%check
%{__python3} setup.py test


%files
%defattr(-,root,root)
%doc ChangeLog AUTHORS README COPYING COPYING.LESSER examples/
%{python3_sitearch}/libvirt.py*
%{python3_sitearch}/libvirtaio.py*
%{python3_sitearch}/libvirt_qemu.py*
%{python3_sitearch}/libvirt_lxc.py*
%{python3_sitearch}/__pycache__/libvirt.cpython-*.py*
%{python3_sitearch}/__pycache__/libvirt_qemu.cpython-*.py*
%{python3_sitearch}/__pycache__/libvirt_lxc.cpython-*.py*
%{python3_sitearch}/__pycache__/libvirtaio.cpython-*.py*
%{python3_sitearch}/libvirtmod*
%{python3_sitearch}/*egg-info


%changelog
